#include <QFile>
#include <QString>
#include <QHostAddress>
#include <readFile.h>

ReadFile::ReadFile()
{
	QFile configuration("/etc/prophet.ini");
}

float ReadFile::getBeta()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="BETA=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toFloat();
		}
		line=configuration.readLine();
		
	}
	configuration.close();
	return (float)0.25;
}

float ReadFile::getGamma()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="GAMMA=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toFloat();
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	return (float)0.99;
}

float ReadFile::getPEncounter()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="PENCOUNTER=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toFloat();
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	return (float)0.75;
}

int ReadFile::getSmartOffer()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="SMARTOFFER=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toInt();
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	return 1000;
}

int ReadFile::getListenerTimer()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="LISTENERTIMER=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toInt();
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	return 1000;
}

int ReadFile::getQueue()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="QUEUE=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toInt();
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	return 0;
}

int ReadFile::getInitiatorTimer()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="INITIATORTIMER=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toInt();
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	return 1000;
}
int ReadFile::getUseTTL()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="USETTL=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toInt();
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	return 0;

}

int ReadFile::getTTL()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="TTLVALUE=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toInt();
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	return 100000;

}

int ReadFile::getUseACKS()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="USEACKS=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toInt();
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	return 0;
}

int ReadFile::getHelloTimer()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="HELLOTIMER=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toInt();
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	return 1000;
}

int ReadFile::getAgingTimer()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="AGINGTIMER=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toInt();
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	return 1000;
}

int ReadFile::getDTNHostPort()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="DTNHOSTPORT=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toInt();
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	return 21;

}	

int ReadFile::getStorageSize()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="STORAGESIZE=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toInt();
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	return 1000;

}	

int ReadFile::getMemoryStorageSize()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="MEMORYSTORAGESIZE=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toInt();
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	return 1000;

}	

int ReadFile::getAlive()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="ALIVE=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toInt();
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	return 15;

}	


int ReadFile::getBroadcastTimer()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="BROADCASTTIMER=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toInt();
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	return 1000;

}


int ReadFile::getHello()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="HELLO=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toInt();
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	return 1;

}


int ReadFile::getRouting()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="ROUTING=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toInt();
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	return 1;
}

int ReadFile::getDTNTimer()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="DTNTIMER=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toInt();
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	return 1000;
}



int ReadFile::getAgeFileNodes()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="AGEFILENODES=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toInt();
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	return 1;
}

int ReadFile::getContiniusUpdate()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="CONTINIUSUPDATE=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toInt();
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	return 1;
}


int ReadFile::getNodeId()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="NODEID=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toInt();
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	return 0;
}

int ReadFile::getUseFileBundles()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="USEFILEBUNDLES=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toInt();
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	return 1;
}


int ReadFile::getWriteToFileTimer()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="WRITETOFILETIMER=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toInt();
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	return 60;
}

int ReadFile::getUseFileHash()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="USEFILEHASH=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toInt();
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	return 1;
}


int ReadFile::getLogOption()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="LOGGING=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toInt();
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	return 60;
}	

int ReadFile::getUseFileNodes()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="USEFILENODES=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			return line.toInt();
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	return 0;
}	

QString ReadFile::getNodeName()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="NODENAME=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			line.chop(1);
			return line;
		}
		line=configuration.readLine();
		
	}
		configuration.close();

	QString ret="unknown";
	return ret;
}

QString ReadFile::getStoragePath()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="STORAGEPATH=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			line.chop(1);
			return line;
		}
		line=configuration.readLine();
		
	}
	QString ret="";
		configuration.close();

	return ret;
}

QString ReadFile::getLogPath()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="LOGPATH=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			line.chop(1);
			return line;
		}
		line=configuration.readLine();
		
	}
	QString ret="";
			configuration.close();

	return ret;
}
QString ReadFile::getMsgPath()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="MSGPATH=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			line.chop(1);
			return line;
		}
		line=configuration.readLine();
		
	}
	QString ret="";
		configuration.close();

	return ret;
}

QHostAddress ReadFile::getNodeIp()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="NODEIP=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			QHostAddress ip(line);
			return ip;

		}
		line=configuration.readLine();
	
	}
		configuration.close();

	QHostAddress ret("192.168.10.1");
	return ret;
}

QHostAddress ReadFile::getBroadcast()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="NODEBROADCAST=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			QHostAddress ip(line);
			return ip;

		}
		line=configuration.readLine();
	}
	QHostAddress ret("255.255.255.255");
		configuration.close();

	return ret;

}

QHostAddress ReadFile::getNodeIp2()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="NODEIP2=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			QHostAddress ip(line);
			return ip;

		}
		line=configuration.readLine();
	
	}
	QHostAddress ret("192.168.10.1");
		configuration.close();

	return ret;

}

QHostAddress ReadFile::getDTNHostName()
{
	QFile configuration("/etc/prophet.ini");
	configuration.open(QIODevice::ReadOnly | QIODevice::Text);
	QString line;
	QString search="DTNHOSTNAME=";
	line=configuration.readLine();
	while(line.size()>0)
	{
		if(line.indexOf(search)!=-1)
		{
			line.remove(search,Qt::CaseInsensitive);
			QHostAddress ip(line);
			return ip;

		}
		line=configuration.readLine();
	
	}
	QHostAddress ret("192.168.10.1");
		configuration.close();

	return ret;

}
