#ifndef BUNDLEWIDGET_H
#define BUNDLEWIDGET_H
#include <QtGui>
#include <QtNetwork>
#include <bundle.h>


class BundleWidget : public QWidget
{

	Q_OBJECT

public:

	BundleWidget(QWidget *parent = 0);
	QTableWidget *table;
	QPushButton *removeSelected;
	QPushButton *removeAll;

signals:
	void removeBundle(int);
	void removeAllBundles();
public slots:
	void removeSelectedSlot();
	void removeAllSlot();
	void getBundleList(QList<Bundle>);



};

#endif


