#ifndef MSGWIDGET_H
#define MSGWIDGET_H
#include <QtGui>
#include <bundle.h>
#include <nodeManager.h>
#include <bundleManager.h>

class MsgWidget : public QWidget
{

	Q_OBJECT

private:
		
	QLineEdit *label;

	
public:
	QComboBox *combo;
	QTextBrowser *readText;
	QFileDialog *file;
	QLineEdit *src;
	QLineEdit *dst;
	QLineEdit *opt;
	QTextEdit *line;
	QLineEdit *srcLine;
	QLineEdit *dstLine;
	MsgWidget(NodeManager*,BundleManager*,QWidget *parent = 0);
	NodeManager* nodeManager;
	BundleManager* bundleManager;
	QTimer* timer;
	bool firstTime;
	QListWidget* msgList;
	QDir dir;
	int sourceId;
	int ackOption;
	QString sourceStr;

signals:
	void sendBundle(Bundle);
	
public slots:
        void composeBundle();
	void getBundle(Bundle newBundle);
	void updateLists();
	void updatedNodeList(NodeManager* ptr);
	void showMsg(QListWidgetItem *);
};

#endif


